/** @file win_csurface.h

	Skelton for retropc emulator

	@author Sasaji
	@date   2013.10.30 -

	@brief [ csurface ]
*/

#ifndef _WIN_CSURFACE_H_
#define _WIN_CSURFACE_H_

#include <windows.h>
#include "../../common.h"

/**
	@brief manage DIB section
*/
class CSurface
{
protected:
	HDC       hMainDC;
	HANDLE    hMainBuf;
	HBITMAP   hMainBmp;
	scrntype *pMainBuf;

	bool      enable;

	bool Create(HDC hdc, long width, long height, HANDLE *hBuf, HBITMAP *hBmp, scrntype **pBuf, HDC *hdcDib);
	void Release(HANDLE *hBuf, HBITMAP *hBmp, HDC *hdcDib);

public:
	CSurface();
	CSurface(HDC hdc, long width, long height);
	virtual ~CSurface();

	bool Create(HDC hdc, long width, long height);
	void Release();

	scrntype *GetBuffer();
	int GetBufferSize();

	bool IsEnable();

	int Width();
	int Height();

	HDC GetDC() { return hMainDC; }
	HANDLE GetHHeader() { return hMainBuf; }
	HBITMAP GetBitmap() { return hMainBmp; }
	LPBITMAPINFOHEADER GetHeader();
	DWORD GetHeaderSize();

	bool Lock();
	void Unlock();

	int Blit(int src_x, int src_y, CSurface &dst, int dst_x, int dst_y, int dst_w, int dst_h);
};

#endif
