/** @file win_emu.cpp

	Skelton for retropc emulator

	@author Takeda.Toshiya
	@date   2006.08.18 -

	@note
	Modified for MBS1 by Sasaji at 2011.06.17

	@brief [ win32 emulation i/f ]
*/

#include "win_emu.h"
#include "../../config.h"
#include "../../fileio.h"
#include "../../gui/gui.h"
//#include "ledbox.h"
#ifdef USE_MESSAGE_BOARD
#include "../../msgboard.h"
#endif
#include "win_csurface.h"

void EMU::set_handle(HWND hwnd, HINSTANCE hinst)
{
	// store main window handle
	main_window_handle = hwnd;
	instance_handle = hinst;
}

#ifdef USE_DIRECT3D
void EMU::change_screen_use_direct3d(int num)
{
	const _TCHAR *list[] = {
		_TX("Direct3D OFF"),
		_TX("Direct3D ON (Sync)"),
		_TX("Direct3D ON (Async)"),
		NULL
	};

	if(enable_direct3d) {
		uint8_t pre_num = config.use_direct3d;

		if (num >= 0) {
			config.use_direct3d = (pre_num == num) ? 0 : num;
		} else {
			config.use_direct3d = (pre_num + 1) % 3;
		}

		lock_screen();

		if (config.use_direct3d != 0) {
			set_d3dpresent_interval();
			reset_d3device(main_window_handle);
		}

		if (pD3Device != NULL && pre_num == 0 && config.use_direct3d != 0) {
			copy_d3dsuf_dib(pD3Dorigin, sufOrigin->GetBuffer(), false);
//			copy_d3dsuf_dib(pD3Dorigin, lpBmp, false);
		} else if (pre_num != 0 && config.use_direct3d == 0) {
			copy_d3dsuf_dib(pD3Dorigin, sufOrigin->GetBuffer(), true);
//			copy_d3dsuf_dib(pD3Dorigin, lpBmp, true);
		}

		unlock_screen();

		out_infof_x(list[config.use_direct3d]);
//		update_config();
	}
}
#endif
